/*
 * Debugger for FM OPL2 from Qemu-5.0.0
 * 
 */
#include <stdio.h>
#include "qemu/osdep.h"
#include "fmopl.h"

/*
 * Stuff we will use:

 typedef void (*OPL_TIMERHANDLER)(void *param, int channel, double interval_Sec);
X FM_OPL *OPLCreate(int clock, int rate);
X void OPLDestroy(FM_OPL *OPL);

void OPLSetTimerHandler(FM_OPL *OPL, OPL_TIMERHANDLER TimerHandler,
                        void *param);

int OPLWrite(FM_OPL *OPL,int a,int v);
unsigned char OPLRead(FM_OPL *OPL,int a);
int OPLTimerOver(FM_OPL *OPL,int c);

void YM3812UpdateOne(FM_OPL *OPL, int16_t *buffer, int length);
*/

int main(int argc, char **argv)
{
    int16_t buf[1024];
    FILE *f;
    FM_OPL *fm = OPLCreate(3579545, 44100);
    if(fm == 0)
    {
        fprintf(stderr, "Error: OPLCreate failed.\n");
        return 1;
    }
    YM3812UpdateOne(fm, buf, sizeof(buf)/sizeof(int16_t));
    f = fopen("fm1.bin", "wb");
    if(f == 0)
    {
        fprintf(stderr, "Error: fopen(\"fm1.bin\", \"wb\") failed.\n");
        OPLDestroy(fm);
        return 1;
    }
    fwrite(buf, sizeof(buf), 1, f);
    fclose(f);
    OPLDestroy(fm);
    return 0;
}
